#ifndef _UE_H_
#define _UE_H_
#include <vector>
#include <iostream>
#include <fstream>
#include "struct.h"
#include <Eigen/Dense>
using namespace std;
using namespace Eigen;

class UE
{
public:
	UE();
	~UE();

	void Configure(int);
	void Allocate_memory(void);
	void Set_UE_speed_indoor_outdoor_state(void);
	void Set_2D_distance_indoor(void);
	void Set_O2I_penet_loss(void);
	void Set_car_penet_loss(void);
	void Set_h_UT(void);
	void Drop_ue_in_cell(void);
	void Determine_LOS(int sec_idx);
	void Set_breakpoint_distance(int sec_idx);
	void Compute_PathLoss(int sec_idx);
	void Compute_antenna_gain(int sec_idx);

	int    *LOS_condition;
	
	int  ue_indoor_outdoor_state;
	int     *adj_sector;
	double  h_UT;
	double  speed;
	double  v[3];
	double	*_2D_distance;
	
	double  *ue2sector_azimuth_angle;
	

	double *phi_LOS_AOD;
	double *phi_LOS_AOA;
	double *theta_LOS_ZOD;
	double *theta_LOS_ZOA;

	double *ZOD_offset;

	double  *break_point_distance;
	double  *pathloss;
	double  *antennagain;

	double  *LS_gain;
	
	double   _2D_distance_indoor;
	double     geometry;
	double     Pathloss_tw;
	double     Pathloss_car;
	int *propagation_condition;

	double bearing_angle;

	int mycell;
	int sector_in_control;
	int floor_idx;
	
	LOCATION pos_in_cell;
	LOCATION pos_indoor;
	LOCATION *pos;

	ArrayXd  *TLSPs;
	ArrayXd  *LSPs;
	
	double *sigma_SF;

	


private:

	int     _ue_idx;
	

};

#endif